        /* Copyright (c) 2007 by IBM Corporation */
        
dojo.provide("zero.form.common.components.BaseWrapperContainer");

dojo.require("dojox.uuid.generateRandomUuid");
dojo.require("dijit._Widget");
dojo.require("zero.form.common.components.UidMixin");
dojo.require("zero.form.common.components.WidgetFactory");

dojo.declare("zero.form.common.components.BaseWrapperContainer",
             [dijit._Widget, 
             zero.form.common.components.UidMixin],
{

        numberOfFields: 0,
		messageWrapperType :'messageWrapper',
        
	    createElement: function(creationParams) 
        {
			var wrapper = this.createWrapper(creationParams);
			this.wireWrapper(wrapper, creationParams);
			this.onSuccessfullCreation(wrapper);
			wrapper.startup();
            return wrapper;         
	    },

		createWrapper: function(creationParams)
		{
           var wrapper = this.instantiateWrapper(creationParams);
           
		    if(!creationParams.sibling)
            {
				this.containerNode.appendChild(wrapper.domNode);
            }
            
			return wrapper;			
		},

		getWidgetFactory: function()
		{
			return this.widgetFactory || (this.widgetFactory = new zero.form.common.components.WidgetFactory());	
		},
		

		instantiateWrapper: function(creationParams)
		{
			var wrapperType = this.getWrapperType(creationParams.type);
			var wrapper = this.getWidgetFactory().createWidget(wrapperType,
                                                creationParams,
                                                creationParams.sibling && creationParams.sibling.domNode,
                                                'after');
            var wrapperId = wrapper.getUid();
            wrapper.domNode.id = "tr_"+wrapperId;
											
			return wrapper;			
		},

		wireWrapper: function(wrapper, creationParams)
		{
			if (creationParams.title !== undefined)
			{
				creationParams.title = (typeof creationParams.title === 'string')?creationParams.title:creationParams.title.getTitle();
			}
			else
			{
				creationParams.title = "";
			}
			this.finalizeWrapperCreation(wrapper, creationParams); 
			wrapper.setWrapperContainer(this);
            return wrapper;         			
		},

		decreaseWrapperCount: function()
		{
			this.numberOfFields = this.numberOfFields-1;
 	        if(this.numberOfFields == 0)
 	        {
 				this.handleEmptyContainer(true);
            }	
		},
	
		increaseWrapperCount: function()
		{
			if(this.numberOfFields == 0)
 	        {
                this.handleEmptyContainer(false);
            }
            this.numberOfFields = this.numberOfFields+1;			
		},

        wrapperSelected: function(id,evt)
        {
			if(this.disabled)
				return;
			if(typeof(id) != "string") // try somehow to have type safety
                return;
	        var wrapper = dijit.byId(id);
	        if(this.selectedWrapper != null && this.selectedWrapper.id != wrapper.id)
                this.selectedWrapper.wrapperDeselected(evt);
            wrapper.wrapperSelected();
            this.selectedWrapper = wrapper;
            this.onSelection(wrapper);
	    },
	    
	    getWrappers: function()
	    {
            var trChildren = [];
	    	var allChildren = this.containerNode.childNodes;
			// finding all the nodes that are actually the domNodes of wrappers (start with tr_)
	    	for(var i = 0;i<allChildren.length;i++)
	    	{
	    	    if(allChildren[i].id != null && allChildren[i].id.indexOf("tr_") == 0)
					trChildren.push(allChildren[i].id.substring(3));
	    	}
	    	var wrappers = [];
			// deducing from these domNodes id's the wrappers
	    	var theWrapper;
			for(var j=0;j<trChildren.length;j++)
	    	{
	    	    theWrapper = dijit.byId(trChildren[j]);
				
				wrappers.push(theWrapper);
	    	}
	    	return wrappers;
	    },
	    
	    removeAll: function()
	    {
	        // destroy all wrappers
	        var wrappers = this.getWrappers();

	        for (var i=0, sz=wrappers.length; i<sz; i++)
	        {
	            wrappers[i].removePressed();
	        }
	    },
		
	    removePressed: function(wrapper)
	    {
			this.decreaseWrapperCount();
            this.onRemovePressed(wrapper);
	    },
	    
	    removeFinished: function(wrapper)
	    {
            this.onRemovePressed(wrapper);
	    },

        /*cloneWrapper: function(wrapper)
        {
            var creationParams = {};
			creationParams.title = wrapper.getTitle();
			creationParams.creationType = "clone";
			creationParams.sibling = wrapper;
			return this.createElement(wrapper.getType(),creationParams);
        },*/
        		
		setDisabled: function(isDisabled)
		{
			var wrappers = this.getWrappers();
			for (var i=0;i<wrappers.length;i++)
			{
				wrappers[i].setDisabled(isDisabled);
			}
		},

		getWrapperType: function(type){},
		
		handleEmptyContainer: function(becomingEmpty){},// becomingEmpty : true - the container is becoming empty, false: the container is now becoming not empty
		finalizeWrapperCreation: function (wrapper, creationParams){},// to be overide 
        onSuccessfullCreation: function(wrapper){},// callbacks
        onSelection: function(wrapper){},// callback
	    onRemovePressed: function(wrapper){},// callback
//        onAddFieldClicked: function(event){},// callback
        onRemovePressed: function(){}// callback
});
