/* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.properties.WidthPropertyMixin");

dojo.require("zero.form.widget.field.properties.PropertyHandler");

dojo.declare(
    "zero.form.widget.field.properties.WidthPropertyMixin", 
    zero.form.widget.field.properties.PropertyHandler,
    {
		initialWidth: null,
		
		update: function()
		{
			if(this.initialWidth == null)
			{
                if (undefined != this.widget.clientWidth)
                {
				    this.initialWidth = this.clientWidth;
                }
                else
                {
                    this.initialWidth = 0;
                }
			}
	
			var widthFactor = 1;
			if(this.widget.widthProperty == LENGTH_PROPERTY_LONG)
			{
				widthFactor = 1.5;
			}
			else if(this.widget.widthProperty == LENGTH_PROPERTY_SHORT)
			{
				widthFactor = 0.5;
			}
			var nodesToEdit = this.getNodesToResize();
			var widthString = (this.initialWidth <= 0)?(15*widthFactor)+"em" : (this.initialWidth*widthFactor)+"px";
			for (var i = 0; i < nodesToEdit.length; i++) 
			{
				nodesToEdit[i].style.width = widthString;
			}
		},

		getNodesToResize: function()
		{
			return (this.widget.getNodesToResize &&  this.widget.getNodesToResize()) || [this.widget.textbox || this.widget.domNode];
		} 
});
